#!/usr/bin/perl 

use strict;
use warnings;

use Chart::Clicker::Renderer::Area;
use Chart::Clicker;
use Chart::Clicker::Axis;
use Chart::Clicker::Axis::DateTime;
use Chart::Clicker::Data::DataSet;
use Chart::Clicker::Data::Series;
use Chart::Clicker::Decoration::Grid;
use Chart::Clicker::Decoration::Label;
use Chart::Clicker::Decoration::Legend;
use Chart::Clicker::Decoration::Plot;
use Chart::Clicker::Drawing qw(:positions);
use Chart::Clicker::Drawing::Insets;
use Chart::Clicker::Drawing::Color;
use Chart::Clicker::Drawing::ColorAllocator;

my $renderer = Chart::Clicker::Renderer::Area->new();
$renderer->options({
        opacity => .8,
});

my $values = [
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          '1.116',
          '1.152',
          0,
          '2.124',
          '5.112',
          '5.724',
          '5.22',
          '7.164',
          '1.296',
          '6.588',
          '6.552',
          '3.708',
          '2.84400000000001',
          '3.744',
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          '5.03999999999999',
          '4.896',
          '1.692',
          '5.364',
          '4.428',
          '5.364',
          '2.952',
          '0.900000000000001',
          '0.900000000000001',
          0,
          0,
          0,
          '1.51199999999999',
          '2.34',
          0,
          '1.476',
          0,
          '1.512',
          0,
          0,
          0,
          0,
          '3.31199999999999',
          0,
          0,
          '1.476',
          '0.468000000000008',
          '1.00799999999999',
          '1.36800000000001',
          0,
          0,
          0,
          '1.94400000000001',
          '2.016',
          0,
          0,
          '0.431999999999992',
          '1.44',
          0,
          0,
          '0.504000000000004',
          '2.66400000000001',
          0,
          0,
          '2.95199999999999',
          '1.94400000000001',
          0,
          0,
          0,
          '2.916',
          0,
          0,
          0,
          '1.22399999999999',
          0,
          '4.06800000000001',
          '4.46399999999999',
          0,
          0,
          0,
          '1.54800000000001',
          '3.96',
          '3.92399999999999',
          0,
          '1.76400000000001',
          0,
          0,
          '3.42',
          '3.88799999999999',
          0,
          0,
          0,
          0,
          '0.432000000000012',
          '3.56399999999999',
          '3.38400000000001',
          '0.900000000000001',
          '4.896',
          '5.04',
          '3.492',
          '4.392',
          '4.68',
          '3.672',
          '4.21200000000002',
          '4.57199999999998',
          '0.504000000000024',
          0,
          0,
          '1.40400000000001',
          '2.556',
          0,
          0,
          '3.276',
          '3.52799999999997',
          '3.70800000000003',
          '4.28399999999997',
          0,
          '4.03200000000004',
          '1.79999999999996',
          '2.73600000000002',
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          '3.92400000000001',
          '1.61999999999998',
          0,
          '2.95199999999999',
          '4.64400000000001',
          '4.28400000000001',
          '3.70799999999999',
          '4.57200000000002',
          '3.996',
          0,
          '1.40400000000001',
          0,
          0,
          '1.72800000000001',
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          '1.90799999999999',
          '1.94399999999999',
          '2.88',
          '1.26000000000002',
          0,
          0,
          0,
          0,
          '1.79999999999996',
          '2.70000000000002',
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          0,
          '1.836',
          '3.24',
          '4.392',
          '4.53600000000002',
          '3.16799999999997',
          '4.716',
          '4.89600000000002',
          0,
          0,
          0,
          '1.94399999999999',
          '0.900000000000021',
          '11.232',
          '3.59999999999996',
          0,
          '4.68',
          0,
          0,
          0,
          0,
          0
        ];

my $keys = [
          5,
          15,
          25,
          35,
          45,
          55,
          65,
          75,
          85,
          95,
          105,
          115,
          125,
          135,
          145,
          155,
          165,
          175,
          185,
          195,
          205,
          215,
          225,
          235,
          245,
          255,
          265,
          275,
          285,
          295,
          305,
          315,
          325,
          335,
          345,
          355,
          365,
          375,
          385,
          395,
          405,
          415,
          425,
          435,
          445,
          455,
          465,
          475,
          485,
          495,
          505,
          515,
          525,
          535,
          545,
          555,
          565,
          575,
          585,
          595,
          605,
          615,
          625,
          635,
          645,
          655,
          665,
          675,
          685,
          695,
          705,
          715,
          725,
          735,
          745,
          755,
          765,
          775,
          785,
          795,
          805,
          815,
          825,
          835,
          845,
          855,
          865,
          875,
          885,
          895,
          905,
          915,
          925,
          935,
          945,
          955,
          965,
          975,
          985,
          995,
          1005,
          1015,
          1025,
          1035,
          1045,
          1055,
          1065,
          1075,
          1085,
          1095,
          1105,
          1115,
          1125,
          1135,
          1145,
          1155,
          1165,
          1175,
          1185,
          1195,
          1205,
          1215,
          1225,
          1235,
          1245,
          1255,
          1265,
          1275,
          1285,
          1295,
          1305,
          1315,
          1325,
          1335,
          1345,
          1355,
          1365,
          1375,
          1385,
          1395,
          1405,
          1415,
          1425,
          1435,
          1445,
          1455,
          1465,
          1475,
          1485,
          1495,
          1505,
          1515,
          1525,
          1535,
          1545,
          1555,
          1565,
          1575,
          1585,
          1595,
          1605,
          1615,
          1625,
          1635,
          1645,
          1655,
          1665,
          1675,
          1685,
          1695,
          1705,
          1715,
          1725,
          1735,
          1745,
          1755,
          1765,
          1775,
          1785,
          1795,
          1805,
          1815,
          1825,
          1835,
          1845,
          1855,
          1865,
          1875,
          1885,
          1895,
          1905,
          1915,
          1925,
          1935,
          1945,
          1955,
          1965,
          1975,
          1985,
          1995,
          2005,
          2015,
          2025,
          2035,
          2045,
          2055,
          2065,
          2075,
          2085,
          2095,
          2105,
          2115,
          2125,
          2135,
          2145,
          2155,
          2165,
          2175,
          2185,
          2195
        ];

my $series = new Chart::Clicker::Data::Series({
    keys   => $keys,
    values => $values,
});
$series->name('Test data shopping, 2007/05/05, 14:02 - 14:38');

my $chart = Chart::Clicker->new({
    datasets => [
        Chart::Clicker::Data::DataSet->new({
                series => [ $series ],
        }),
    ],
    width => 700,
    height => 250,
});
$chart->color_allocator(
    Chart::Clicker::Drawing::ColorAllocator->new({
        colors => [ 
            Chart::Clicker::Drawing::Color->new({
                red   => 0,
                blue  => 0.7,
                green => 0,
            }),
        ],
    }),
);
#$chart->add(
#    Chart::Clicker::Decoration::Legend->new({
#        margins => Chart::Clicker::Drawing::Insets->new({
#            top => 5,
#        }),
#    }),
#    $CC_BOTTOM,
#);

# Domain axis
# DateTime axis with formatter string seems to be broken
#my $daxis = Chart::Clicker::Axis::DateTime->new({
#    orientation => $CC_HORIZONTAL,
#    position    => $CC_BOTTOM,
#    label       => 'Time (s)',
#});
#$daxis->formatter('%H:%M:%S');
my $daxis = Chart::Clicker::Axis->new({
    orientation => $CC_HORIZONTAL,
    position    => $CC_BOTTOM,
    format      => '%02d',
    label       => 'Time (s)',
});
$chart->add($daxis, $CC_AXIS_BOTTOM);

# Range axis
my $raxis = Chart::Clicker::Axis->new({
    orientation => $CC_VERTICAL,
    position    => $CC_LEFT,
    format      => '%0.2f',
    label       => 'Speed (km/h)',
});
$chart->add($raxis, $CC_AXIS_LEFT);

$chart->range_axes([ $raxis ]);
$chart->domain_axes([ $daxis ]);

$chart->add(Chart::Clicker::Decoration::Grid->new(), $CC_CENTER, 0);

my $plot = Chart::Clicker::Decoration::Plot->new();
$plot->renderers([ $renderer ]);
$chart->add($plot, $CC_CENTER);
$plot->set_renderer_for_dataset(1, 1);

$chart->prepare();
$chart->draw();
$chart->write('/tmp/chart.png');

